/*------------------------------------------------------------------------------*/
/*                    Ajout des bibliothques ncessaires                       */
/*------------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <fstream>


/*------------------------------------------------------------------------------*/
/*                    Dfinition des structures ncessaires                     */
/*------------------------------------------------------------------------------*/

typedef struct INFO {int typeInf; char Nom[50];} INFO;
/* Types d'objets utiliss dans le script : */
/* De 0  4 : variables locales */
/*		0 = variable de type short */
/*		1 = variable de type float */
/*		2 = variable de type long */
/*		3 = variable de type rfrence */
/*		4 = variable de type inconnu */
/* De 5  9 : variables globales */
/*		5 = variable de type short */
/*		6 = variable de type float */
/*		7 = variable de type long */
/*		8 = variable de type rfrence */
/*		9 = variable de type inconnu */
/* De 25  29 : variables locales externes */
/*		25 = variable de type short */
/*		26 = variable de type float */
/*		27 = variable de type long */
/*		28 = variable de type rfrence */
/*		29 = variable de type inconnu */
/* De 10  19 : objets physiques "gnriques" */
/*      10 = contenant (PNJ, coffre, etc...) */
/*      11 = contenu, c'est  dire objet physique pouvant tre mis dans un contenant (ingrdient, misc, arme, etc...) */
/*      12 = objet activable */
/*      13 = contenant activable */
/*      14 = contenu activable */
/*      15 = personne */
/*      16 = objet quipable */
/*      19 = objet quelconque */
/* De 30  49 : objets physiques dtermins */
/*      30 = joueur */
/*      31 = PNJ */
/*      32 = arme */
/*      33 = armure */
/*      34 = vtements */
/*      35 = outil de rparation */
/*      36 = sondes */
/*      37 = crochets */
/*      38 = misc */
/*      39 = lumire */
/*      40 = ingrdient */
/*      41 = porte */
/*      42 = coffre */
/*      43 = livre */
/*      44 = instrument d'alchimiste */
/*      45 = activateur */
/*      46 = crature */
/*      47 = potion */
/*      48 = leveled creature */
/*      49 = leveled item */
/* De 50  59 : dialogues */
/*      50 = topic */
/*      51 = entre journal */
/* De 60  99 : autres */
/*      60 = type d'objet */
/*      61 = classe */
/*      62 = package */
/*      63 = temps */
/*      64 = signe de naissance */
/*      65 = style de combat */
/*      66 = faction ou PNJ */
/*      67 = game setting */
/*      68 = monde */
/*      80 = GAMESETTING */
/*      81 = INISETTING */
/*      90 = rgion */
/*      91 = faction */
/*      92 = fichier */
/*      93 = son */
/*      94 = animation */
/*      95 = cellule */
/*      96 = script */
/*      97 = race */
/*      99 = nom du script en cours */
/* De 20  24 : objets du jeu non physiques */
/*      20 = sort */
/*      21 = effets */

typedef struct ERREUR {int ligneErr; char messageErr[200]; int niveau;} ERREUR;
/* Dclaration de la structure des erreurs :
        ligneErr : ligne  laquelle l'erreur a t commise
        messageErr : message de l'erreur commise
*/

typedef struct VAR_LOCALE {char var[50]; char obj[50];} VAR_LOCALE;
/* Dclaration de la structure des variables locales :
        var : nom de la variable locale
        obj : objet auquel la variable est associe
*/

typedef struct TYPE_SC {int ligneType; int typeSc;} TYPE_SC;
/* Dclaration de la structure contenant les types de script :
      ligneType : ligne  laquelle on a dtect une spcificit d'un des types de script
      typeSc : type de script (1 = qute, 2 = objet, 3 = effet magique)
*/



/*------------------------------------------------------------------------------*/
/*              Dclaration des fonctions et routines ncessaires               */
/*------------------------------------------------------------------------------*/

/* Fonctions diverses */
int typeChar(char c); // Type du caractre en entre
int mini(int k, int l); // Minimum de deux entiers
int maxi(int k, int l); // Maximum de deux entiers
void int2str(char *c, int n); // Conversion d'un entier en chane de caractres
int isStat(char ligne[50]); // Renvoit 1 si la chane de caractres en entre est une statistique
int isSex(char ligne[50]); // Renvoit 1 si la chane de caractres en entre est un sexe
void typeScriptWrite(int type, int ligne); // Ecriture du type de script  chaque fois qu'on dtecte une spcificit d'un des types existants
void typeScriptAnalyse(int typeMain); // Vrification qu'il n'y a pas incompatibilit entre tous les types de scripts dtects (c'est le cas s'il y en a plus d'un)
int XorExt(INFO inf, INFO inf2); // Ou exclusif sur le caractre "variable externe" de deux objets du script
int XorQuete(INFO inf, INFO inf2); // Ou exclusif sur le caractre "qute" de deux objets du script
int isRef(char objet[50]); // Renvoit 1 si la chane de caractres en entre est une rfrence
void synDetectBadTab(char ligne[5000], int nLigne); // Recherche des tabulations  risque

/* Fonction de dtection de la validit des imbrications de test */
int checkTest(int nbLignes, char ScNom[50]);

/* Fonctions de dtection de mots dans une chaine de caractres */
void strDetectTest(int *ligneTest, int nbLignes, char ScNom[50], char testChar[9]);
int strDetectVar(int nbLignes, char ScNom[50], char varChar[6]);

/* Fonction de traitement des informations */
void triInfo(INFO inf);
void triInfoLocal(VAR_LOCALE varLoc);

/* Fonctions de vrification de syntaxe */

// Type "Fonction"
void strFonctionSeule(char fonction[50], char ligne[5000], int *trouveFonc, int nLigne);
// Type "(ID.)Fonction"
void strFonctionSeule_OptCall(char fonction[50], char ligne[5000], int *ligneTraitee, int nLigne, int typeAppelant=0);
// Type "(ID.)Fonction ID"
void strFoncIDApp(char fonction[50], int type, int typeID, char ligne[5000], int *trouveFonc, int nLigne);
// Type "Fonction ID"
void strFoncID(char fonction[50], int typeID, char ligne[5000], int *trouveFonc, int nLigne);
// Type "(ID.)Fonction sexe" si app = 1 et "Fonction sexe" sinon
void strFoncSexe_choiceApp(char fonction[50], int ID1, int app, char ligne[5000], int *trouveFonc, int nLigne);
// Type "(ID.)Fonction stat" si app = 1 et "Fonction stat" sinon
void strFoncStat_choiceApp(char fonction[50], int ID1, int app, char ligne[5000], int *trouveFonc, int nLigne);
// Type "(ID.)Fonction stat short" si app = 1 et "Fonction stat short" sinon
void strFoncStatShort_choiceApp(char fonction[50], int ID1, int app, char ligne[5000], int *trouveFonc, int nLigne);
// Type "(ID.)Fonction axe"
void strFoncAxe(char fonction[50], int type, char ligne[5000], int *trouveFonc, int nLigne);
// Type "(ID.)Fonction axe float"
void strFoncAxeFloat(char fonction[50], int type, char ligne[5000], int *trouveFonc, int nLigne);
// Type "(ID.)Fonction short"
void strFoncValShortApp(char fonction[50], int type, char ligne[5000], int *trouveFonc, int nLigne);
// Type "Fonction short"
void strFoncValShort(char fonction[50], char ligne[5000], int *trouveFonc, int nLigne, int minus=0);
// Type "(ID.)Fonction (short)" si app = 1 et "Fonction (short)" sinon
void strFonc_optShort_choiceApp(char fonction[50], char ligne[5000], int ID1, int app, int *ligneTraitee, int nLigne);
// Type "Fonction float"
void strFoncValFloat(char fonction[50], char ligne[5000], int *trouveFonc, int nLigne, int minus=0);
// Type "(ID.)Fonction float"
void strFoncValFloatApp(char fonction[50], int ID1, char ligne[5000], int *trouveFonc, int nLigne);
// Type "(ID.)Fonction ID short" si app = 1 et "Fonction ID short" sinon
void strFoncIDshort_choiceApp(char fonction[50], int typeID, int typeID2, int app, char ligne[5000], int *ligneTraitee, int nLigne);
// Type "(ID.)Fonction ID float"
void strFoncIDfloat(char fonction[50], int typeID, int typeID2, char ligne[5000], int *ligneTraitee, int nLigne, int obse);
// Type "(ID.)Fonction ID ID" si app = 1 et "Fonction ID ID" sinon
void strFoncIDID_choiceApp(char fonction[50], char ligne[5000], int typeID1, int typeID2, int typeID3, int app, int *ligneTraitee, int nLigne);
// Type "Fonction ID ID short"
void strFoncIDIDshort(char fonction[50], char ligne[5000], int typeID1, int typeID2, int *ligneTraitee, int nLigne);
// Type "(ID.)Fonction ID (short)" si app = 1 et "Fonction ID (short)" sinon
void strFoncID_optShort_choiceApp(char fonction[50], char ligne[5000], int ID1, int ID2, int app, int *ligneTraitee, int nLigne);
// Type "(ID.)Fonction ID (float)" si app = 1 et "Fonction ID (float)" sinon
void strFoncID_optFloat_choiceApp(char fonction[50], char ligne[5000], int ID1, int ID2, int app, int *ligneTraitee, int nLigne);
// Type "(ID.)Fonction "texte" (float)" si app = 1 et "Fonction ID (float)" sinon
void strFoncTexte_optFloat_choiceApp(char fonction[50], char ligne[5000], int ID1, int app, int *ligneTraitee, int nLigne);
// Type "Fonction (ID)"
void strFonc_optID_choiceApp(char fonction[50], int ID1, int ID2, int app, char ligne[5000], int *ligneTraitee, int nLigne);
// Type "(ID.)Fonction (ID) (short)"
void strFonc_optID_optShort(char fonction[50], int ID1, int ID2, char ligne[5000], int *ligneTraitee, int nLigne);
// Type "Fonction ID (ID)"
void strFoncID_optID(char fonction[50], int ID1, int ID2, char ligne[5000], int *ligneTraitee, int nLigne);
// Type "Fonction short (ID)"
void strFoncShort_optID(char fonction[50], int ID1, char ligne[5000], int *ligneTraitee, int nLigne, int appelant=0, int ID=0);
// Type "(ID.)Fonction float float float ID"
void strFoncFloatFloatFloatIDApp(char fonction[50], char ligne[5000], int ID1, int ID2, int *ligneTraitee, int nLigne);
// Type "(ID.)Fonction float float float"
void strFoncFloatFloatFloatApp(char fonction[50], char ligne[5000], int ID1, int *ligneTraitee, int nLigne, int appelant, int minus=0);
// Type "(ID.)Fonction float float float float float float"
void strFoncFloatX6App(char fonction[50], char ligne[5000], int ID1, int *ligneTraitee, int nLigne, int appelant, int minus=0);
// Type "(ID.)Fonction float float float float"
void strFoncFloatX4App(char fonction[50], char ligne[5000], int ID1, int *ligneTraitee, int nLigne, int appelant, int minus=0);
// Type "(ID.)Fonction float float"
void strFoncFloatFloatApp(char fonction[50], char ligne[5000], int ID1, int *ligneTraitee, int nLigne, int appelant, int minus=0);
// Type "(ID.)Fonction (ID) (ID)"
void strFonc_optID_optID(char fonction[50], int ID1, int ID2, int ID3, char ligne[5000], int *ligneTraitee, int nLigne);
// Non documente
void strFoncUndocumented(char fonction[50], char ligne[5000], int *trouveFonc, int nLigne);
// Sur le modle de MessageBox
void synDetectMessageBox(char fonction[50], char ligne[5000], int *ligneTraitee, int nLigne, int obse);

// Dtection des fonctions au traitement particulier
void synDetectTEST(char fonction[50], char ligne[5000], int *ligneTraitee, int nLigne, int obse);
void synDetectBegin(char ligne[5000], int *ligneTraitee, int nLigne, int typeSc);
void synDetectMessage(char ligne[5000], int *ligneTraitee, int nLigne, int obse);
void synDetectSetActorFullName(char ligne[5000], int *ligneTraitee, int nLigne);
void synDetectSetCellFullName(char ligne[5000], int *ligneTraitee, int nLigne);
void synDetectPlaceAtMe(char ligne[5000], int *ligneTraitee, int nLigne);
void synDetectMoveToMarker(char ligne[5000], int *ligneTraitee, int nLigne);
void synDetectMoveTo(char ligne[5000], int *ligneTraitee, int nLigne);
void synDetectForceActorValue(char ligne[5000], int *trouveFonc, int nLigne, int obse);
void synDetectForceAV(char ligne[5000], int *trouveFonc, int nLigne, int obse);
void synDetectModPCMiscStat(char ligne[5000], int *trouveFonc, int nLigne);
void synDetectModPCMS(char ligne[5000], int *trouveFonc, int nLigne);
void synDetectLock(char ligne[5000], int *ligneTraitee, int nLigne);
void synDetectSetLevel(char ligne[5000], int *ligneTraitee, int nLigne);
void synDetectRemoveItem(char ligne[5000], int *ligneTraitee, int nLigne);
void synDetectSayTo(char ligne[5000], int *ligneTraitee, int nLigne);
void synDetectGetCrimeKnown(char ligne[5000], int *ligneTraitee, int nLigne);
void synDetectEssentialDeathReload(char ligne[5000], int *ligneTraitee, int nLigne);


/* Fonction de dtection de la syntaxe */
void syntaxe(int nbLignes, char ScNom[50], int typeSc, int obse); // Fonction principale de dtection de la syntaxe
int expression(char ligne[5000], int nLigne, int obse); // Fonction de dtection de la validit d'une expression
void logique(char fonction[50], char ligne[5000], int nLigne, int obse); // Fonction de dtection de la validit d'une expression logique
void logiqueBegin(char ligne[5000], int nLigne, int typeSc); // Fonction de dtection de la validit d'un bloc Begin
void synDetectSetTo(char ligne[5000], int *ligneTraitee, int nLigne, int obse); // Fonction de dtection de la validit d'un Set ... to ...
void synDetectCommande(char ligne[5000], int nLigne, int typeSc); // Fonction de dtection de la validit d'une commande
void synDetectUnderscore(); // Fonction de dtection des objets dont le nom commence par un underscore
