#include "header.h"
#include <windows.h>

void ecritureLog(char logNom[64], int nbLignes, int valInfo, int niveau, int* mess);


/*------------------------------------------------------------------------------------------------*/
/*                                      Fonction principale                                       */
/*------------------------------------------------------------------------------------------------*/

int mainDebug(char ScNom[50], int* mess, int valInfo, int typeSc, int obse, int niveau) {

FILE *fScript, *fLog;
int SizeScript=0, k=0, l, nbLignes=1, compteur=0, test=0, choix, res;
char logNom[64]="Correction de ", *texteScript, c;

/* Effacement des fichiers temporaires (s'il en existe un de ce nom avant le lancement de l'xecutable, par exemple en cas de crash prcdent de l'excutable) */
remove("DbTempTES4");
remove("InfTempTES4");
remove("InfTempTES4.2");
remove("InfTempTES4.3");




/*------------------------------------------------------------------------------*/
/* Acquisition du texte du script et ouverture du fichier contenant les erreurs */
/*------------------------------------------------------------------------------*/

fScript = fopen(ScNom, "rt");

/* Message si le fichier contenant le script est impossible  ouvrir. */
if ( fScript == NULL ) {
   return 2;
}

/* Vrification si le fichier contenant le log d'erreur existe dj ou non */
strcat(logNom, ScNom);

/* Recherche de la longueur du texte cod et allocation dynamique de mmoire selon cette longueur */
while ( getc(fScript) != EOF ) {
      SizeScript++;
}
rewind(fScript);

texteScript = (char*)malloc((SizeScript+1)*sizeof(char));

/* Remplissage de la chane de caractres texteScript par le script contenu dans le fichier */
compteur = 1;
while( (c=getc(fScript)) != EOF ) {
       texteScript[k] = c;
       if ( c == '\n' ) compteur++;
       k++;
}
texteScript[k] = '\0';
fclose(fScript);

fScript = fopen("DbTempTES4", "wb");
fclose(fScript);
fScript = fopen("InfTempTES4", "wb");
fclose(fScript);
fScript = fopen("InfTempTES4.2", "wb");
fclose(fScript);
fScript = fopen("InfTempTES4.3", "wb");
fclose(fScript);



/*------------------------------------------------------------------------------*/
/*                  Recherche du nombre de lignes dans le texte                 */
/*------------------------------------------------------------------------------*/

/* Recherche du nombre de retours charriot dans le script (correspond au nombre de lignes-1 car la premire ligne n'est pas prcde par un retour charriot) */
for ( k = 0; k < SizeScript; k++ ) {
    if ( texteScript[k] == '\n' ) nbLignes++;
}
free(texteScript);




/*------------------------------------------------------------------------------*/
/*                       Recherche des variables locales                        */
/*------------------------------------------------------------------------------*/

res = strDetectVar(nbLignes, ScNom, "short");
if ( res != 0 ) return res;

res = strDetectVar(nbLignes, ScNom, "float");
if ( res != 0 ) return res;

res = strDetectVar(nbLignes, ScNom, "long");
if ( res != 0 ) return res;

res = strDetectVar(nbLignes, ScNom, "ref");
if ( res != 0 ) return res;


/*------------------------------------------------------------------------------*/
/*                Traitement des ventuelles erreurs de if/while                */
/*------------------------------------------------------------------------------*/

res = checkTest(nbLignes+1, ScNom);
if ( res != 0 ) return 10;



/*------------------------------------------------------------------------------*/
/*                          Traitement de la syntaxe                            */
/*------------------------------------------------------------------------------*/

syntaxe(nbLignes, ScNom, typeSc, obse);



/*------------------------------------------------------------------------------*/
/*                       Gestion des types de script                            */
/*------------------------------------------------------------------------------*/

typeScriptAnalyse(typeSc);



/*------------------------------------------------------------------------------*/
/*                    Traitement des noms d'objet avec "_"                      */
/*------------------------------------------------------------------------------*/

synDetectUnderscore();



/*------------------------------------------------------------------------------*/
/*                          Ecriture du log final                               */
/*------------------------------------------------------------------------------*/

ecritureLog(logNom, nbLignes, valInfo, niveau, mess);


/* Fin du dbuguage */
printf("\n\n");
fLog = fopen(logNom, "rt");
if ( fLog != NULL ) return 1;
fclose(fLog);
return 0;

}
