/*------------------------------------------------------------------------------------------------*/
/*                                        Fonctions diverses                                      */
/*------------------------------------------------------------------------------------------------*/

#include "header.h"



/*------------------------------------------------------------------------------------------------*/
/*                  Fonction permettant de dtecter le type du caractre                          */
/*------------------------------------------------------------------------------------------------*/
/* Renvoit : */
/* 0 si le caractre est non reconnu */
/* 1 si le caractre est un sparateur (espace, point virgule et retour chariot) */
/* 2 si le caractre est alphabtique ou est un underscore */
/* 3 si le caractre est un nombre */
/* 4 si le caractre est un regroupeur (parenthses et guillemets) */
/* 5 si le caractre est un oprateur logique (gal, infrieur, suprieur) */

int typeChar(char c) {

if ( isspace(c) != 0 ) return 1;
if ( c == '	' ) return 1;
if ( c == ';' ) return 1;

if ( isalpha(c) != 0 ) return 2;
if ( c == '_' ) return 2;

if ( isdigit(c) != 0 ) return 3;

if ( c == '(' ) return 4;
if ( c == ')' ) return 4;
if ( c == '"' ) return 4;

if ( c == '=' ) return 5;
if ( c == '<' ) return 5;
if ( c == '>' ) return 5;

return 0;

}





/*------------------------------------------------------------------------------------------------*/
/*          Fonction permettant de dtecter si la chaine est une statistique ou non               */
/*------------------------------------------------------------------------------------------------*/

int isStat(char ligne[50]) {

char test[50], stat[50];
int k;

strcpy(test, ligne);
for ( k = 0; k < strlen(test); k++ ) {
    if ( isalpha(test[k]) != 0 ) test[k] = tolower(test[k]);
}

strcpy(stat, "strength");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "intelligence");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "willpower");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "agility");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "speed");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "endurance");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "personality");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "luck");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "health");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "magicka");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "fatigue");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "encumbrance");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "armorer");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "athletics");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "blade");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "block");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "blunt");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "handtohand");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "heavyarmor");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "alchemy");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "alteration");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "conjuration");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "destruction");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "illusion");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "mysticism");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "restoration");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "acrobatics");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "lightarmor");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "marksman");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "mercantile");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "security");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "sneak");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "speechcraft");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "aggression");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "confidence");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "energy");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "responsibility");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "bounty");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "magickamultiplier");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "nighteyebonus");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "attackbonus");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "defendbonus");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "castingpenalty");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "blindness");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "chameleon");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "invisibility");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "paralysis");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "silence");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "confusion");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "detectitemrange");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "spellabsorbchance");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "spellreflectchance");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "swimspeedmultiplier");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "waterbreathing");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "waterwalking");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "stuntedmagicka");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "detectliferange");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "reflectdamage");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "telekinesis");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "resistfire");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "resistfrost");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "resistdisease");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "resistmagic");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "resistnormalweapons");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "resistparalysis");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "resistpoison");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "resistshock");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "vampirism");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "darkness");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

strcpy(stat, "resistwaterdamage");
if ( strncmp(test, stat, maxi(strlen(test), strlen(stat))) == 0 ) return 1;

return 0;

}





/*------------------------------------------------------------------------------------------------*/
/*               Fonction permettant de dtecter si la chaine est un sexe ou non                  */
/*------------------------------------------------------------------------------------------------*/

int isSex(char ligne[50]) {

char test[50], sex[50];
int k;

strcpy(test, ligne);
for ( k = 0; k < strlen(test); k++ ) {
    if ( isalpha(test[k]) != 0 ) test[k] = tolower(test[k]);
}

strcpy(sex, "male");
if ( strncmp(test, sex, maxi(strlen(test), strlen(sex))) == 0 ) return 1;

strcpy(sex, "female");
if ( strncmp(test, sex, maxi(strlen(test), strlen(sex))) == 0 ) return 1;

return 0;

}





/*------------------------------------------------------------------------------------------------*/
/*              Fonction permettant de dtecter le plus petit de deux entiers                     */
/*------------------------------------------------------------------------------------------------*/

int mini(int k, int l) {

if ( k < l ) return k;
return l;

}




/*------------------------------------------------------------------------------------------------*/
/*              Fonction permettant de dtecter le plus grand de deux entiers                     */
/*------------------------------------------------------------------------------------------------*/

int maxi(int k, int l) {

if ( k > l ) return k;
return l;

}




/*------------------------------------------------------------------------------*/
/*  Fonction convertissant les entiers (jusque 999999) en chanes de caractres */
/*------------------------------------------------------------------------------*/

void int2str(char *c, int n) {

char cInt[7];
int test=0, k=0, nb;

if ( n == 0 ) {
     *(c+0) = '0';
     for ( k = 1; k < 7; k++ ) *(c+k) = '\0';
}
else {
     nb = n;
     while ( test == 0 ) {
           if ( nb == 0 ) test = 1;
           if ( k > 6 ) test = 1;
           if ( test == 0 ) {
                cInt[k] = char(48+(nb%10));
                nb = nb - nb%10;
                nb = nb/10;
                k++;
           }
     }

     for ( test = 0; test < k; test++ ) {
         *(c+test) = cInt[k-test-1];
     }
     for ( test = k; test < 7; test++ ) {
         *(c+test) = '\0';
     }
}

}






// Dtection du "ou exclusif" sur des variables externes/autres objets
int XorExt(INFO inf, INFO inf2) {

int var, var2;

if ( ( inf.typeInf >= 25 ) && ( inf.typeInf <= 29 ) ) var = 1;
else var = 0;

if ( ( inf2.typeInf >= 25 ) && ( inf2.typeInf <= 29 ) ) var2 = 1;
else var2 = 0;

var = var + var2;

if ( var == 1 ) return 1;

return 0;

}






// Dtection du "ou exclusif" sur des qutes/autres objets
int XorQuete(INFO inf, INFO inf2) {

int var, var2;

if ( inf.typeInf == 51 ) var = 1;
else var = 0;

if ( inf2.typeInf == 51 ) var2 = 1;
else var2 = 0;

var = var + var2;

if ( var == 1 ) return 1;

return 0;

}






// Dtection des types de script
void typeScriptWrite(int type, int ligne) {
     
FILE *fTSc;
TYPE_SC tSc;

fTSc = fopen("InfTempTES4.2", "ab");
if ( fTSc == NULL ) {
   printf("Impossible d'ouvrir le fichier \"InfTempTES4.2\" depuis le fichier source \"typeScript.cpp\".\n\n");
   system("PAUSE");
   exit(1);
}

tSc.ligneType = ligne;
tSc.typeSc = type;
fwrite(&tSc, sizeof(TYPE_SC), 1, fTSc);
fclose(fTSc);

}






// Dtection des types de script
void typeScriptAnalyse(int typeMain) {
     
FILE *fTSc, *fErr;
TYPE_SC tSc;
ERREUR err;
char cInt[7], cTemp[200];
int k=0, Quest=0, Object=0, Magic=0, nbTypes=0;
  
fTSc = fopen("InfTempTES4.2", "rb");
if ( fTSc != NULL ) {

     while ( fread(&tSc, sizeof(TYPE_SC), 1, fTSc) != 0 ) {
           if ( typeMain == 0 ) {
                if ( tSc.typeSc == 1 ) Quest++;
                if ( tSc.typeSc == 2 ) Object++;
                if ( tSc.typeSc == 3 ) Magic++;
           }
           else {
                if ( tSc.typeSc != typeMain ) {
                     fErr = fopen("DbTempTES4", "ab");
                     if ( fErr == NULL ) {
                          printf("Impossible d'ouvrir le fichier \"DbTempTES4\" depuis le fichier source \"typeScript.cpp\".\n\n");
                          system("PAUSE");
                          exit(1);
                     }
                     err.ligneErr = tSc.ligneType;
                     err.niveau = 2;
                     strcpy(err.messageErr, "    - Ligne ");
                     int2str(&(cInt[0]), tSc.ligneType+1);
                     strcat(err.messageErr, cInt);
                     strcat(err.messageErr, " : erreur, votre script ");
                     if ( typeMain == 1 ) strcat(err.messageErr, "de qute");
                     if ( typeMain == 2 ) strcat(err.messageErr, "d'objet");
                     if ( typeMain == 3 ) strcat(err.messageErr, "d'effet magique");
                     strcat(err.messageErr, " utilise une spcificit des scripts ");
                     if ( tSc.typeSc == 1 ) strcat(err.messageErr, "de qute");
                     if ( tSc.typeSc == 2 ) strcat(err.messageErr, "d'objet");
                     if ( tSc.typeSc == 3 ) strcat(err.messageErr, "d'effet magique");
                     strcat(err.messageErr, " !");
                     fwrite(&err, sizeof(ERREUR), 1, fErr);
                     fclose(fErr);
                }
           }
     }

     if ( typeMain == 0 ) {
     
          if ( Quest != 0 ) nbTypes++;
          if ( Object != 0 ) nbTypes++;
          if ( Magic != 0 ) nbTypes++;
          if ( nbTypes >= 2 ) {
               rewind(fTSc);
               fErr = fopen("DbTempTES4", "ab");
               if ( fErr == NULL ) {
                    printf("Impossible d'ouvrir le fichier \"DbTempTES4\" depuis le fichier source \"typeScript.cpp\".\n\n");
                    system("PAUSE");
                    exit(1);
               }
               err.ligneErr = -1;
               err.niveau = 2;
               strcpy(err.messageErr, "    - Erreur, le script a plusieurs types :");
               while ( fread(&tSc, sizeof(TYPE_SC), 1, fTSc) != 0 ) {
                     strcpy(cTemp, "\n        * Ligne ");
                     int2str(&(cInt[0]), tSc.ligneType+1);
                     strcat(cTemp, cInt);
                     strcat(cTemp, " : script ");
                     if ( tSc.typeSc == 1 ) strcat(cTemp, "de qute");
                     if ( tSc.typeSc == 2 ) strcat(cTemp, "d'objet");
                     if ( tSc.typeSc == 3 ) strcat(cTemp, "d'effet magique");
                     if ( ( strlen(err.messageErr) + strlen(cTemp) ) < 149 ) strcat(err.messageErr, cTemp);
                     else {
                          if ( k == 0 ) {
                               strcat(err.messageErr, "\n        ...et d'autres aux lignes suivantes.");
                               k = 1;
                          }
                     }
               }
               fwrite(&err, sizeof(ERREUR), 1, fErr);
               fclose(fErr);
          }
     }

     fclose(fTSc);
}

}







void synDetectBadTab(char ligne[5000], int nLigne) {
     
     
FILE *fInf, *fErr;
int k, l, m, mem, test=0, compteur, check=0, var, trouve=0;
char IDobjet[5000], IDobjet2[50], nbItem[7], cInt[7];
ERREUR err;
INFO inf;

for ( k = 0; k < strlen(ligne); k++ ) {
    if ( isalpha(ligne[k]) != 0 ) ligne[k] = tolower(ligne[k]);
}

k=0;
while ( ( ( ligne[k] == ' ' ) || ( ligne[k] == '\t' ) ) && ( k < strlen(ligne) ) ) k++;

compteur = 0;
while ( k < strlen(ligne) ) {
      if ( ligne[k] == '\t' ) compteur++;
      k++;
}

if ( compteur > 0 ) {
     fErr = fopen("DbTempTES4", "ab");
     if ( fErr == NULL ) {
          printf("Impossible d'ouvrir le fichier \"DbTempTES4\" depuis le fichier source \"typeScript.cpp\".\n\n");
          system("PAUSE");
          exit(1);
     }
     err.ligneErr = nLigne;
     err.niveau = 1;
     strcpy(err.messageErr, "    - Ligne ");
     int2str(&(cInt[0]), nLigne+1);
     strcat(err.messageErr, cInt);
     strcat(err.messageErr, " : alerte, ");
     int2str(&(cInt[0]), compteur);
     strcat(err.messageErr, cInt);
     strcat(err.messageErr, " tabulation");
     if ( compteur > 1 ) strcat(err.messageErr, "s ont t detectes");
     else strcat(err.messageErr, " a t detecte");
     strcat(err.messageErr, " aprs le premier caractre (risques de plantage in-game).");
     fwrite(&err, sizeof(ERREUR), 1, fErr);
     trouve = 1;
     fclose(fErr);
}

}





// Fonction renvoyant 1 si l'objet appel est une variable de type rfrence, 0 si ce n'est pas le cas ou si l'objet n'a pas t trouv
int isRef(char objet[50]) {

FILE *fInf;
int test, k;
INFO inf;

fInf = fopen("InfTempTES4", "rb");
if ( fInf == NULL ) {
   printf("Impossible d'ouvrir le fichier \"InfTempTES4\" depuis le fichier source \"isRef.cpp\".\n\n");
   system("PAUSE");
   exit(1);
}

test = 0;
for ( k = 0; k < strlen(objet); k++ ) {
    if ( isalpha(objet[k]) != 0 ) objet[k] = tolower(objet[k]);
}
while ( fread(&inf, sizeof(INFO), 1, fInf) != 0 ) {
      for ( k = 0; k < strlen(inf.Nom); k++ ) {
          if ( isalpha(inf.Nom[k]) != 0 ) inf.Nom[k] = tolower(inf.Nom[k]);
      }
      if ( strncmp(objet, inf.Nom, maxi(strlen(objet), strlen(inf.Nom))) == 0 ) {
           if ( ( inf.typeInf == 3 ) || ( inf.typeInf == 8 ) ) {
                fclose(fInf);
                return 1;
           }
      }
}

fclose(fInf);
return 0;

}





void synDetectUnderscore() {

FILE *fErr, *fInf;
INFO inf;
ERREUR err;

fErr = fopen("DbTempTES4", "ab");
if ( fErr == NULL ) {
     printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES3\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n");
     system("PAUSE");
     exit(1);
}

fInf = fopen("InfTempTES4", "rb");
if ( fInf == NULL ) {
   printf("Impossible d'ouvrir le fichier \"InfTempTES3\" depuis le fichier source \"MainTriInfo.cpp\".\n\n");
   system("PAUSE");
   fclose(fErr);
   exit(1);
}

while ( fread(&inf, sizeof(INFO), 1, fInf) != 0 ) {
      if ( (inf.Nom)[0] == '_' ) {
           err.ligneErr = -1;
           err.niveau = 1;
           strcpy(err.messageErr, "    - Le premier caractre de \"");
           strcat(err.messageErr, inf.Nom);
           strcat(err.messageErr, "\" est un underscore, risques de bugs in-game.");
           fwrite(&err, sizeof(ERREUR), 1, fErr);
      }
}

fclose(fErr);
fclose(fInf);

}
