#include "header.h"
#include <windows.h>



/*------------------------------------------------------------------------------*/
/* Fonction permettant d'crire le log dfinitif  partir du fichier temporaire */
/*------------------------------------------------------------------------------*/

void ecritureLog(char logNom[64], int nbLignes, int valInfo, int niveau, int* mess) {

FILE *fLog, *fTemp, *fLoc;
ERREUR err;
INFO inf, nSc;
VAR_LOCALE varLoc;
int nbErreurs=0, nbAlertes=0, k, l, nbInfos=0, test;
int infVarLocal=0, infVarGlobal=0, infVarLocalExt=0, infObjPhys=0, infObjNPhys=0, infDial=0, infAutres=0, nbInfDual=0;
int nomSc=0;
char version[]= "2.05";

/* Ouverture du log et du fichier temporaire */
fLog = fopen(logNom, "wt");
if ( fLog == NULL ) {
   printf("Erreur : impossible d'ouvrir le fichier \"%s\" !\n\n", logNom);
   system("PAUSE");
   exit(1);
}

fTemp = fopen("InfTempTES4", "rb");
if ( fTemp == NULL ) {
   printf("Erreur : impossible d'ouvrir le fichier temporaire \"InfTempTES4\" !\n\n");
   system("PAUSE");
   fclose(fLog);
   exit(1);
}

/* Acquisition du nom du script */
l=0;
rewind(fTemp);
while ( fread(&inf, sizeof(INFO), 1, fTemp) != 0 ) {
     if ( inf.typeInf == 99 ) {
          nSc = inf;
          l = 1;
     }
}
fclose(fTemp);

/* Ecriture de l'en-tte du log */
fputs("                     DebugTES4 version ", fLog);
fputs(version, fLog);
if ( l == 1 ) {
     fputs(" : script \"", fLog);
     fputs(nSc.Nom, fLog);
     fputs("\"", fLog);
}
fputs("\n                    --------------------", fLog);
for ( k = 0; k < strlen(version); k++ ) putc('-', fLog);
if ( l == 1 ) {
     fputs("------------", fLog);
     for ( k = 0; k < strlen(nSc.Nom); k++ ) putc('-', fLog);
}



/*------------------------------------------------------------------------------*/
/*                 Ecriture des bugs trouvs dans le script                     */
/*------------------------------------------------------------------------------*/

fTemp = fopen("DbTempTES4", "rb");
if ( fTemp == NULL ) {
   printf("Erreur : impossible d'ouvrir le fichier temporaire \"DbTempTES4\" !\n\n");
   system("PAUSE");
   fclose(fLog);
   exit(1);
}


/* Lecture des bugs trouvs */
while ( fread(&err, sizeof(ERREUR), 1, fTemp) != 0 ) {
      if ( err.niveau == 1 ) nbAlertes++;
      else nbErreurs++;
}
rewind(fTemp);

*mess = nbErreurs;

if ( ( nbErreurs == 0 ) && ( nbAlertes == 0 ) ) {
     fputs("\n\n\n\n   Aucun bug n'a t trouv sur ce script.\n\n", fLog);
}
else {
     int erreursAdded = 0;
     fputs("\n\n\n Liste des erreurs :\n---------------------\n", fLog);
     for ( k = 0; k < nbLignes; k++ ) {
         rewind(fTemp);
         while ( fread(&err, sizeof(ERREUR), 1, fTemp) != 0 ) {
               if ( err.ligneErr == k ) {
                    if ( err.niveau != niveau ) {
                         fputs(err.messageErr, fLog);
                         fputs("\n", fLog);
                         erreursAdded++;
                    }
               }
         }
     }
     rewind(fTemp);
     while ( fread(&err, sizeof(ERREUR), 1, fTemp) != 0 ) {
           if ( err.ligneErr == -1 ) {
                if ( err.niveau != niveau ) {
                     fputs(err.messageErr, fLog);
                     fputs("\n", fLog);
                     erreursAdded++;
                }
           }
     }
     if ( erreursAdded == 0 ) fputs("\tAucune erreur dtecte, mais le dbugueur a trouv des failles au script.\n\tDcochez l'option \"Ne pas afficher les alertes\" dans le menu \"Prfrences\" pour les voir.\n", fLog);
}

fclose(fTemp);



/*------------------------------------------------------------------------------*/
/*              Ecriture des informations trouves sur le script                */
/*------------------------------------------------------------------------------*/

fTemp = fopen("InfTempTES4", "rb");
if ( fTemp == NULL ) {
   printf("Erreur : impossible d'ouvrir le fichier temporaire \"InfTempTES4\" !\n\n");
   system("PAUSE");
   fclose(fLog);
   exit(1);
}

/* Lecture des informations trouvs */
if ( fread(&inf, sizeof(INFO), 1, fTemp) != 0 ) {
     nbInfos++;
}
rewind(fTemp);

if ( nbInfos != 0 ) {
     /* Recherche des types d'informations trouves */
     while ( fread(&inf, sizeof(INFO), 1, fTemp) != 0 ) {
     /* Types d'objets utiliss dans le script : */
            /* De 0  9 : variables locales */
            /*		0 = variable de type short */
            /*		1 = variable de type float */
            /*		2 = variable de type long */   
           if ( inf.typeInf == -99 ) nbInfDual = 1;                                                              
           if ( inf.typeInf >= 0 ) {
              if ( inf.typeInf <= 4 ) {
                   infVarLocal = 1;
              }
           }    
           if ( inf.typeInf >= 5 ) {
              if ( inf.typeInf <= 9 ) {
                   infVarGlobal = 1;
              }
           }
           if ( inf.typeInf >= 25 ) {
              if ( inf.typeInf <= 29 ) {
                   infVarLocalExt = 1;
              }
           }
           if ( inf.typeInf >= 10 ) {
              if ( inf.typeInf <= 19 ) {
                   infObjPhys = 1;
              }
           }   
           if ( inf.typeInf >= 20 ) {
              if ( inf.typeInf <= 24 ) {
                   infObjNPhys = 1;
              }
           }  
           if ( inf.typeInf >= 30 ) {
              if ( inf.typeInf <= 49 ) {
                   infObjPhys = 1;
              }
           }                                     
           if ( inf.typeInf >= 50 ) {
              if ( inf.typeInf <= 59 ) {
                   infDial = 1;
              }
           }    
           if ( inf.typeInf >= 60 ) {
                if ( inf.typeInf < 99 ) {
                     infAutres = 1;
                }
           }                                  
     }
     rewind(fTemp);
}

if ( valInfo == 1 ) {
if ( infVarLocal == 1 ) {
   fputs("\n\n\n Liste des variables locales utilises :\n-----------------------------------------\n", fLog);
   while ( fread(&inf, sizeof(INFO), 1, fTemp) != 0 ) {
         if ( inf.typeInf == 0 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type SHORT)\n", fLog);
         }
         if ( inf.typeInf == 1 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type FLOAT)\n", fLog);
         }
         if ( inf.typeInf == 2 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type LONG)\n", fLog);
         }
         if ( inf.typeInf == 3 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type REFERENCE)\n", fLog);
         }
         if ( inf.typeInf == 4 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type indtermin)\n", fLog);
         }         
   }
   rewind(fTemp);
}


if ( infVarLocalExt == 1 ) {
   fputs("\n\n\n Liste des variables locales externes utilises :\n--------------------------------------------------\n", fLog);
   while ( fread(&inf, sizeof(INFO), 1, fTemp) != 0 ) {
         if ( inf.typeInf == 25 ) {
              test = 0;
              fLoc = fopen("InfTempTES4.3", "rb");
              if ( fLoc == NULL ) {
                 printf("Erreur : impossible d'ouvrir le fichier temporaire \"InfTempTES4.3\" !\n\n");
                 system("PAUSE");
                 exit(1);
              }
              while ( fread(&varLoc, sizeof(VAR_LOCALE), 1, fLoc) != 0 ) {
                    if ( strncmp(varLoc.var, inf.Nom, maxi(strlen(varLoc.var), strlen(inf.Nom))) == 0 ) {
                         fputs("    - \"", fLog);
                         fputs(inf.Nom, fLog);
                         fputs("\" (variable de type SHORT attache  l'objet \"", fLog);
                         fputs(varLoc.obj, fLog);
                         fputs("\")\n", fLog);
                         test++;
                    }
              }
              fclose(fLoc);
              if ( test == 0 ) {
                   fputs("    - \"", fLog);
                   fputs(inf.Nom, fLog);
                   fputs("\" (type SHORT)\n", fLog);
              }
         }
         if ( inf.typeInf == 26 ) {
              test = 0;
              fLoc = fopen("InfTempTES4.3", "rb");
              if ( fLoc == NULL ) {
                 printf("Erreur : impossible d'ouvrir le fichier temporaire \"InfTempTES4.3\" !\n\n");
                 system("PAUSE");
                 exit(1);
              }
              while ( fread(&varLoc, sizeof(VAR_LOCALE), 1, fLoc) != 0 ) {
                    if ( strncmp(varLoc.var, inf.Nom, maxi(strlen(varLoc.var), strlen(inf.Nom))) == 0 ) {
                         fputs("    - \"", fLog);
                         fputs(inf.Nom, fLog);
                         fputs("\" (variable de type FLOAT attache  l'objet \"", fLog);
                         fputs(varLoc.obj, fLog);
                         fputs("\")\n", fLog);
                         test++;
                    }
              }
              fclose(fLoc);
              if ( test == 0 ) {
                   fputs("    - \"", fLog);
                   fputs(inf.Nom, fLog);
                   fputs("\" (type FLOAT)\n", fLog);
              }
         }
         if ( inf.typeInf == 27 ) {
              test = 0;
              fLoc = fopen("InfTempTES4.3", "rb");
              if ( fLoc == NULL ) {
                 printf("Erreur : impossible d'ouvrir le fichier temporaire \"InfTempTES4.3\" !\n\n");
                 system("PAUSE");
                 exit(1);
              }
              while ( fread(&varLoc, sizeof(VAR_LOCALE), 1, fLoc) != 0 ) {
                    if ( strncmp(varLoc.var, inf.Nom, maxi(strlen(varLoc.var), strlen(inf.Nom))) == 0 ) {
                         fputs("    - \"", fLog);
                         fputs(inf.Nom, fLog);
                         fputs("\" (variable de type LONG attache  l'objet \"", fLog);
                         fputs(varLoc.obj, fLog);
                         fputs("\")\n", fLog);
                         test++;
                    }
              }
              fclose(fLoc);
              if ( test == 0 ) {
                   fputs("    - \"", fLog);
                   fputs(inf.Nom, fLog);
                   fputs("\" (type LONG)\n", fLog);
              }
         }
         if ( inf.typeInf == 28 ) {
              test = 0;
              fLoc = fopen("InfTempTES4.3", "rb");
              if ( fLoc == NULL ) {
                 printf("Erreur : impossible d'ouvrir le fichier temporaire \"InfTempTES4.3\" !\n\n");
                 system("PAUSE");
                 exit(1);
              }
              while ( fread(&varLoc, sizeof(VAR_LOCALE), 1, fLoc) != 0 ) {
                    if ( strncmp(varLoc.var, inf.Nom, maxi(strlen(varLoc.var), strlen(inf.Nom))) == 0 ) {
                         fputs("    - \"", fLog);
                         fputs(inf.Nom, fLog);
                         fputs("\" (variable de type REFERENCE attache  l'objet \"", fLog);
                         fputs(varLoc.obj, fLog);
                         fputs("\")\n", fLog);
                         test++;
                    }
              }
              fclose(fLoc);
              if ( test == 0 ) {
                   fputs("    - \"", fLog);
                   fputs(inf.Nom, fLog);
                   fputs("\" (type REFERENCE)\n", fLog);
              }
         }
         if ( inf.typeInf == 29 ) {
              test = 0;
              fLoc = fopen("InfTempTES4.3", "rb");
              if ( fLoc == NULL ) {
                 printf("Erreur : impossible d'ouvrir le fichier temporaire \"InfTempTES4.3\" !\n\n");
                 system("PAUSE");
                 exit(1);
              }
              while ( fread(&varLoc, sizeof(VAR_LOCALE), 1, fLoc) != 0 ) {
                    if ( strncmp(varLoc.var, inf.Nom, maxi(strlen(varLoc.var), strlen(inf.Nom))) == 0 ) {
                         fputs("    - \"", fLog);
                         fputs(inf.Nom, fLog);
                         fputs("\" (variable de type indtermin attache  l'objet \"", fLog);
                         fputs(varLoc.obj, fLog);
                         fputs("\")\n", fLog);
                         test++;
                    }
              }
              fclose(fLoc);
              if ( test == 0 ) {
                   fputs("    - \"", fLog);
                   fputs(inf.Nom, fLog);
                   fputs("\" (type indtermin)\n", fLog);
              }
         }       
   }
   rewind(fTemp);
}


if ( infVarGlobal == 1 ) {
   fputs("\n\n\n Liste des variables globales utilises :\n------------------------------------------\n", fLog);
   while ( fread(&inf, sizeof(INFO), 1, fTemp) != 0 ) {
         if ( inf.typeInf == 5 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type SHORT)\n", fLog);
         }
         if ( inf.typeInf == 6 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type FLOAT)\n", fLog);
         }
         if ( inf.typeInf == 7 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type LONG)\n", fLog);
         }
         if ( inf.typeInf == 8 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type REFERENCE)\n", fLog);
         }
         if ( inf.typeInf == 9 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type indtermin)\n", fLog);
         }         
   }
   rewind(fTemp);
}

if ( infObjPhys == 1 ) {
   fputs("\n\n\n Liste des objets physiques utiliss :\n---------------------------------------\n", fLog);
   while ( fread(&inf, sizeof(INFO), 1, fTemp) != 0 ) {
         if ( inf.typeInf == 30 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type JOUEUR)\n", fLog);
         }
         if ( inf.typeInf == 10 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type CONTENANT)\n", fLog);
         }
         if ( inf.typeInf == 11 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type CONTENU)\n", fLog);
         }
         if ( inf.typeInf == 12 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type OBJET ACTIVABLE)\n", fLog);
         }
         if ( inf.typeInf == 15 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type PERSONNE)\n", fLog);
         }
         if ( inf.typeInf == 16 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type OBJET EQUIPABLE)\n", fLog);
         }
         if ( inf.typeInf == 19 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type OBJET)\n", fLog);
         }
         if ( inf.typeInf == 31 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type PNJ)\n", fLog);
         }
         if ( inf.typeInf == 32 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type ARME)\n", fLog);
         }
         if ( inf.typeInf == 35 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type INSTRUMENT DE REPARATION)\n", fLog);
         }
         if ( inf.typeInf == 38 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type MISC)\n", fLog);
         }
         if ( inf.typeInf == 41 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type PORTE)\n", fLog);
         }
         if ( inf.typeInf == 46 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type CREATURE)\n", fLog);
         }
         if ( inf.typeInf == 48 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type LEVELED CREATURE)\n", fLog);
         }
         if ( inf.typeInf == 49 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type LEVELED ITEM)\n", fLog);
         }
   }
   rewind(fTemp);
}



if ( infObjNPhys == 1 ) {
   fputs("\n\n\n Liste des objets non physiques utiliss :\n-------------------------------------------\n", fLog);
   while ( fread(&inf, sizeof(INFO), 1, fTemp) != 0 ) {
         if ( inf.typeInf == 20 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type SORT)\n", fLog);
         }
         if ( inf.typeInf == 21 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type EFFET)\n", fLog);
         }
   }
   rewind(fTemp);
}

if ( infDial == 1 ) {
   fputs("\n\n\n Liste des dialogues utiliss :\n--------------------------------\n", fLog);
   while ( fread(&inf, sizeof(INFO), 1, fTemp) != 0 ) {
         if ( inf.typeInf == 50 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type TOPIC)\n", fLog);
         }
         if ( inf.typeInf == 51 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type QUETE)\n", fLog);
         }         
   }
   rewind(fTemp);
}

if ( infAutres == 1 ) {
   fputs("\n\n\n Liste des autres objets utiliss :\n------------------------------------\n", fLog);
   while ( fread(&inf, sizeof(INFO), 1, fTemp) != 0 ) {
         if ( inf.typeInf == 60 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type TYPE D'OBJET)\n", fLog);
         }
         if ( inf.typeInf == 61 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type CLASSE)\n", fLog);
         }
         if ( inf.typeInf == 62 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type PACKAGE)\n", fLog);
         }
         if ( inf.typeInf == 63 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type TEMPS)\n", fLog);
         }
         if ( inf.typeInf == 64 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type SIGNE DE NAISSANCE)\n", fLog);
         }
         if ( inf.typeInf == 65 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type STYLE DE COMBAT)\n", fLog);
         }
         if ( inf.typeInf == 66 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type FACTION ou PNJ)\n", fLog);
         }
         if ( inf.typeInf == 67 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type GAMESETTING)\n", fLog);
         }
         if ( inf.typeInf == 68 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type MONDE)\n", fLog);
         }
         if ( inf.typeInf == 80 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type GAMESETTING)\n", fLog);
         }
         if ( inf.typeInf == 81 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type INISETTING)\n", fLog);
         }
         if ( inf.typeInf == 90 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type REGION)\n", fLog);
         }
         if ( inf.typeInf == 91 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type FACTION)\n", fLog);
         }         
         if ( inf.typeInf == 92 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type FICHIER)\n", fLog);
         }    
         if ( inf.typeInf == 93 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type SON)\n", fLog);
         }      
         if ( inf.typeInf == 94 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type ANIMATION)\n", fLog);
         }  
         if ( inf.typeInf == 95 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type CELLULE)\n", fLog);
         }     
         if ( inf.typeInf == 96 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type SCRIPT)\n", fLog);
         }     
         if ( inf.typeInf == 97 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type RACE)\n", fLog);
         }                                        
   }
   rewind(fTemp);
}
}

if ( nbInfDual == 1 ) {
   fputs("\n\n\n Liste des variables utilises de manire erronne (utilises comme deux types diffrents) :\n---------------------------------------------------\n", fLog);
   while ( fread(&inf, sizeof(INFO), 1, fTemp) != 0 ) {
         if ( inf.typeInf == -99 ) {
              fputs("    - \"", fLog);
              fputs(inf.Nom, fLog);
              fputs("\" (type ERREUR)\n", fLog);
         }   
   }
   rewind(fTemp);
}



/* Fermeture du log et effacement des fichiers temporaires */
fclose(fLog);
fclose(fTemp);
remove("DbTempTES4");
remove("InfTempTES4");
remove("InfTempTES4.2");
remove("InfTempTES4.3");

}
